require 'net/http'
require 'base64'

def split_fun(con)
	lines = con.split("\n")
	ret = {}
	lines.each do |line|
		list = line.split(' ')
		if list.length == 2
			ret[list[0]] = list[1]
		end
	end
	return ret
end

# return a dict
def bypasscaptcha_submit(key,img_file_name)
	url = URI.parse('http://bypasscaptcha.com/upload.php')

	#read file content
	f = File.open(img_file_name, 'rb')
	img = f.read(100 * 1024) # at most 100k
	f.close()
	img = Base64.encode64(img)

	res = Net::HTTP.post_form(url, { 'key' => key, 'file' => img, 
											'gen_task_id' => '1',
											'base64_code' => '1',
											'vendor_key' => ''
											})
	con = res.body
	return split_fun(con)
end

# return true or false indicating whether successful or not
def bypasscaptcha_feedback(key,task_id,is_correct)
	url = URI.parse('http://bypasscaptcha.com/check_value.php')
	
	res = Net::HTTP.post_form(url, { 'key' => key,
											'task_id' => task_id,
											'cv' => (is_correct ? '1' : '0')
											})

	return res.body == 'OK' ? true : false
end

# return a number with -1 representing the errors
def bypasscaptcha_getleft(key)
	url = URI.parse('http://bypasscaptcha.com/ex_left.php')

	res = Net::HTTP.post_form(url, {'key' => key})

	dict = split_fun(res.body)
	if dict.include? 'Left'
		return Integer(dict['Left'])
	end
	return -1
end

